       #include <sys/types.h>
       #include <sys/stat.h>
       #include <dirent.h>
       #include <unistd.h>
#include "arch/mode_string.c"
       int stat(const char *file_name, struct stat *buf);
       struct dirent *readdir(DIR *dir);
#if 0
       The dirent structure is defined as follows:
              struct dirent {
              #if defined _FILE_OFFSET_BITS && _FILE_OFFSET_BITS == 64
                  ino64_t             d_ino;          /* inode number */
                  off64_t             d_off;          /* offset to the next dirent */
              #else
                  ino_t               d_ino;          /* inode number */
                  off_t               d_off;          /* offset to the next dirent */
              #endif
                  unsigned short int  d_reclen;       /* length of this record */
                  unsigned char       d_type;         /* type of file */
                  char                d_name[256];    /* filename */
              };

#endif
#if 0
#define S_IFMT  00170000
#define S_IFSOCK 0140000
#define S_IFLNK  0120000
#define S_IFREG  0100000
#define S_IFBLK  0060000
#define S_IFDIR  0040000
#define S_IFCHR  0020000
#define S_IFIFO  0010000
#define S_ISUID  0004000
#define S_ISGID  0002000
#define S_ISVTX  0001000

#define S_ISLNK(m)  (((m) & S_IFMT) == S_IFLNK)
#define S_ISREG(m)  (((m) & S_IFMT) == S_IFREG)
#define S_ISDIR(m)  (((m) & S_IFMT) == S_IFDIR)
#define S_ISCHR(m)  (((m) & S_IFMT) == S_IFCHR)
#define S_ISBLK(m)  (((m) & S_IFMT) == S_IFBLK)
#define S_ISFIFO(m) (((m) & S_IFMT) == S_IFIFO)
#define S_ISSOCK(m) (((m) & S_IFMT) == S_IFSOCK)
#endif

int main(int argc,char **argv)
{
struct dirent *dir;
int type;
struct stat statbuf;
struct dnode dnode;
//struct __old_kernel_stat statbuf;
static char fname[200];
int error;

if(argc!=2)return -1;
DIR *d=opendir(argv[1]);
	while(dir=readdir(d))
{
	strcpy(fname,argv[1]);
	if(argv[1][strlen(argv[1])-1]!='/')
	{
		strcat(fname,"/");
	}
	strcat(fname,dir->d_name);
	error=lstat(fname,&statbuf);
	if(error>=0)error=statbuf.st_mode;
	else continue;

	dnode.name=dir->d_name;
	dnode.fullname=fname;
    dnode.dstat=statbuf;
	dnode.next=0;
type=error;
#if 0
#define RWX(type) ((type)&0x4)?'r':'_',((type)&0x2)?'w':'_',((type)&0x1)?'x':'_' 
	printf("%-40s\t%-10s\t%d\t%d\t%x\t%c%c%c%c%c%c%c%c%c%c%c\n",dir->d_name,mode_string(type),(int)dir->d_off,dir->d_ino,type,S_ISDIR(type)?'d':S_ISCHR(type)?'c':S_ISBLK(type)?'b':'_',S_ISLNK(type)?'l':'_',RWX((type>>8)&7),RWX((type>>4)&7),RWX(type&7));
#endif
list_single(&dnode);
printf("\n");
}
closedir(d);
}
